
Redmine - Feature #8691

Better handling of issue update conflict

2011-06-27 11:55 - pasquale [:dedalus]

Status: Closed Start date: 2011-06-27

Priority: High Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 1.4.0   

Resolution: Fixed   

Description

Redmine should be provide some handling of "mid-air collision" as in Bugzilla. Bugzilla does not lock records. It provides mid-air

collision detection, and offers the offending user a choice of options to deal with the conflict:  exit without push changes and push

changes anyway.

For me this is a defect because cause dataloss, but I add it to tracker feature

Related issues:

Has duplicate Redmine - Feature #9292: "Data has been updated by another user... Closed 2011-09-21

Associated revisions

Revision 8774 - 2012-02-04 18:36 - Jean-Philippe Lang

Better handling of issue update conflicts (#8691).

History

#1 - 2011-12-12 09:14 - Etienne Massip

- Target version set to Candidate for next major release

#2 - 2011-12-25 11:24 - pasquale [:dedalus]

- File bugzilla-approach.png added

attached bugzilla-approach.png as proof of concept

#3 - 2012-01-31 10:25 - Nayuta Taga

- File mid_air_collision_patch-20110131-trunk_r8743.patch added

I wrote a patch for this problem.

When "mid-air collision" happens, it shows a conflict resolution menu like:

    ----------------------------------------------------------------

    Feature #8691

    ----------------------------------------------------------------

    Another user's updates

    ----------------------------------------------------------------

    Updated by Foo Bar less than a minute ago                     #3

    ----------------------------------------------------------------

    note note note note ....

    note note note note ....

    note note note note ....

    +--------------------------------------------------------------+

    | (!) * Data has been updated by another user.                 |

    +--------------------------------------------------------------+

    +--------------------------------------------------------------+

    | Conflict Resolution                                          |

    | ( ) Throw away my changes, and show #8691                    |

    | (*) Submit only my new notes                                 |

    | ( ) Edit agein                                               |

    +--------------------------------------------------------------+

    | Notes                                                        |

    | +----------------------------------------------------------+ |
    | |my note my note my note my note ....                      | |

    | |my note my note my note my note ....                      | |

    | |my note my note my note my note ....                      | |

    | |                                                          | |

    | +----------------------------------------------------------+ |

    +--------------------------------------------------------------+

    [Submit] Preview

 If you select "Throw away my changes, and show #8691",

the notes area will be hidden (by javascript) and

the submit button's text will change to "Show #8691".

The button works as same as the #8691 link.

If you select "Submit only my new notes",

you can submit notes only.

Other attributes will never be changed.

This menu does not appear if you wrote no note previously.

If you select "Edit agein", an full update interface is shown.

#4 - 2012-01-31 10:25 - Nayuta Taga

- File mid_air_collision_patch-20110131-tags_1.3.0.patch added

#5 - 2012-01-31 10:31 - Nayuta Taga

- File mid_air_collision_patch-20110131-trunk_r8743-screenshot.png added

#6 - 2012-02-02 12:12 - pasquale [:dedalus]

I have applied patch for 1.3.0 stable release and all works fine: some chance to land it on next 1.4.0 milestone?

#7 - 2012-02-04 18:46 - Jean-Philippe Lang

- File conflict_resolution.png added

- Subject changed from Better handling of "mid-air collision" to Better handling of issue update conflict

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Target version changed from Candidate for next major release to 1.4.0

- Resolution set to Fixed

Feature added in r8774. The proposed patch seems a bit overcomplicated on the controller side but the behaviour was almost preserved, with the

option to apply changes anyway, like in Bugzilla.

 

#8 - 2012-02-09 04:47 - Nayuta Taga

Thank you for fixing this issue.  I'm looking forward to the 1.4.0 release.
#9 - 2013-05-07 17:52 - Josh Cox

Is there any reason this wasn't implemented for the wiki pages as well?

#10 - 2013-05-07 18:37 - Jean-Baptiste Barth

Josh Cox wrote:

Is there any reason this wasn't implemented for the wiki pages as well?

 I don't think so, feel free to file a new feature request in a separate issue if you want (maybe look around before to see if there's not already an issue

for that)

#11 - 2013-05-12 02:53 - Toshi MARUYAMA

Jean-Baptiste Barth wrote:

Josh Cox wrote:

Is there any reason this wasn't implemented for the wiki pages as well?

 I don't think so, feel free to file a new feature request in a separate issue if you want (maybe look around before to see if there's not already an

issue for that)

 For The Record: new issue #13999.

Files

bugzilla-approach.png 38 KB 2011-12-25 pasquale [:dedalus]

mid_air_collision_patch-20110131-trunk_r8743.patch 16.9 KB 2012-01-31 Nayuta Taga

mid_air_collision_patch-20110131-tags_1.3.0.patch 17 KB 2012-01-31 Nayuta Taga

mid_air_collision_patch-20110131-trunk_r8743-screenshot.png 12.1 KB 2012-01-31 Nayuta Taga

conflict_resolution.png 10.4 KB 2012-02-04 Jean-Philippe Lang
